Given(/^I initialize first client connecting to port (\d+)$/) do |port|
  @client1=create_client('localhost', port.to_i)
  @client1.start
  @client2=create_client('localhost', port.to_i)
  @client2.start
  sleep 0.2
  @client1.atomic do |tx|
    tx['admin']='other_value'
  end
end

Then(/^the first client should have state for key "(.*?)"$/) do |key|
  @client1.atomic_read do |tx|
    tx.should have_key(key)
  end
end

Then(/^the first client should be able to change state for key "(.*?)"$/) do |key|
  @client1.atomic do |tx|
    tx[key]='other_value'
  end
  sleep 0.2
  puts "changed!"
  @client1.atomic_read do |tx|
    tx[key].should == 'other_value'
  end

end
