Given(/^I start dp_map_manager on port (\d+) and store state for key "(.*?)"$/) do |port, key|
  run_interactive(unescape("dp_map_manager.rb -p #{port} -s store"))
  wait_for_output("Manager started at port #{port}")
  @server_port=port.to_i

  @client1=create_client('localhost', @server_port)
  @client1.start  
  @client1.atomic do |tx|
    tx[key]='some value'
  end

  # @client1_socket=TCPSocket.new 'localhost', port.to_i
  # send_message(@client1_socket, ClientHelloMessage.new(0))
  # expect_message(@client1_socket, ServerHelloMessage)
  # send_message(@client1_socket, ClientTransactionMessage.new('tx1',{key => [nil,'abc']},{'abc' => 'some value'}))
  # success=expect_message(@client1_socket, ClientTransactionSuccessfulMessage)
  # success.transaction_sequence.should_not be_nil
  # success.transaction_id.should_not be_nil
  # tx=expect_message(@client1_socket, TransactionMessage)
  # tx.transaction_sequence.should == 1

end

Given(/^I shut down dp_map_manager$/) do
  type('quit')
  assert_exit_status(0)
end

When(/^I start server on port (\d+)$/) do |port|
  @server_port=port.to_i
  run_interactive(unescape("dp_map_manager.rb -p #{port} -s store"))
  wait_for_output("Manager started at port #{port}")
end

When(/^I start second client that connects to port (\d+)$/) do |port|
  @client2_socket=TCPSocket.new 'localhost', port
  send_message(@client2_socket, ClientHelloMessage.new(0))
  expect_message(@client2_socket, ServerHelloMessage)
end

Then(/^second client should have data for key "(.*?)"$/) do |key|
  msg=expect_message(@client2_socket, TransactionMessage)
  msg.transitions.should have_key(key)
end


When(/^I wait for (\d+)ms$/) do |ms|
  sleep ms.to_f/1000.0
end
