$LOAD_PATH << File.expand_path('../../../lib',__FILE__)
require 'aruba/cucumber'
require 'dp_stm_map'
require 'tmpdir'
require 'timeout'

include DpStmMap


def wait_for_output expected
  Timeout::timeout(exit_timeout) do
    loop do
      break if assert_partial_output_interactive(expected)
      sleep 0.1
    end
  end
end



Before do
  @tmpdirs=[]
  @clients=[]

end

After do
  # FileUtils.rm_rf @client_temp
  @tmpdirs.each do |tmpdir|
    FileUtils.rm_rf tmpdir
  end

  @clients.each do |client|
    client.stop
  end
end

After do
  begin
    type('quit')
    assert_exit_status(0)
  rescue

  end
end


def make_temp_dir
  tmpdir=Dir.mktmpdir
  @tmpdirs << tmpdir
  tmpdir
end


def send_message socket, message
  yaml=message.serialize
  socket.write([yaml.bytesize].pack("Q>"))
  socket.write(yaml)
  socket.flush
end

def expect_message socket, type
  timeout(3) do
    size=socket.read(8).unpack("Q>")[0]
    message=JsonMessage::deserialize(socket.read(size))

    # puts "message: #{message}"

    message.should be_a type
    message
  end
end



def create_client host, port
  client=DistributedPersistentStmMap.new host,port,make_temp_dir   
  @clients << client
  client
end
